---
title: DOMTokenList
slug: Web/API/DOMTokenList
tags:
  - API
  - DOM
  - DOMTokenList
  - Interface
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p><span class="seoSummary">The <code><strong>DOMTokenList</strong></code> interface represents a set of space-separated tokens. Such a set is returned by {{domxref("Element.classList")}}, {{domxref("HTMLLinkElement.relList")}}, {{domxref("HTMLAnchorElement.relList")}}, {{domxref("HTMLAreaElement.relList")}}, {{domxref("HTMLIframeElement.sandbox")}}, or {{domxref("HTMLOutputElement.htmlFor")}}. It is indexed beginning with <code>0</code> as with JavaScript {{jsxref("Array")}} objects. <code>DOMTokenList</code> is always case-sensitive.</span></p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("DOMTokenList.length")}} {{ReadOnlyInline}}</dt>
 <dd>Is an <code>integer</code> representing the number of objects stored in the object.</dd>
 <dt>{{domxref("DOMTokenList.value")}}</dt>
 <dd>A stringifier property that returns the value of the list as a {{domxref("DOMString")}}.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("DOMTokenList.item()", "DOMTokenList.item(<var>index</var>)")}}</dt>
 <dd>Returns the item in the list by its <code><var>index</var></code>, or <code>undefined</code> if <code><var>index</var></code> is greater than or equal to the list's <code>length</code>.</dd>
 <dt>{{domxref("DOMTokenList.contains()", "DOMTokenList.contains(<var>token</var>)")}}</dt>
 <dd>Returns <code>true</code> if the list contains the given <code><var>token</var></code>, otherwise <code>false</code>.</dd>
 <dt>{{domxref("DOMTokenList.add()", "DOMTokenList.add(<var>token1</var>[, <var>token2</var>[, ...<var>tokenN</var>]])")}}</dt>
 <dd>Adds the specified <code><var>token</var></code>(s) to the list.</dd>
 <dt>{{domxref("DOMTokenList.remove()", "DOMTokenList.remove(<var>token1</var>[, <var>token2</var>[, ...<var>tokenN</var>]])")}}</dt>
 <dd>Removes the specified <code><var>token</var></code>(s) from the list.</dd>
 <dt>{{domxref("DOMTokenList.replace()", "DOMTokenList.replace(<var>oldToken</var>, <var>newToken</var>)")}}</dt>
 <dd>Replaces <code><var>token</var></code> with <code><var>newToken</var></code>.</dd>
 <dt>{{domxref("DOMTokenList.supports()", "DOMTokenList.supports(<var>token</var>)")}}</dt>
 <dd>Returns <code>true</code> if a given <code><var>token</var></code> is in the associated attribute's supported tokens.</dd>
 <dt>{{domxref("DOMTokenList.toggle()", "DOMTokenList.toggle(<var>token</var> [, <var>force</var>])")}}</dt>
 <dd>Removes <code><var>token</var></code> from the list if it exists, or adds <code><var>token</var></code> to the list if it doesn't. Returns a boolean indicating whether <code><var>token</var></code> is in the list after the operation.</dd>
 <dt>{{domxref("DOMTokenList.entries()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols","iterator")}}, allowing you to go through all key/value pairs contained in this object.</dd>
 <dt>{{domxref("DOMTokenList.forEach()", "DOMTokenList.forEach(<var>callback</var> [, <var>thisArg</var>])")}}</dt>
 <dd>Executes a provided <code><var>callback</var></code> function once per <code>DOMTokenList</code> element.</dd>
 <dt>{{domxref("DOMTokenList.keys()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols", "iterator")}}, allowing you to go through all keys of the key/value pairs contained in this object.</dd>
 <dt>{{domxref("DOMTokenList.values()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols", "iterator")}}, allowing you to go through all values of the key/value pairs contained in this object.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the following simple example, we retrieve the list of classes set on a {{htmlelement("p")}} element as a <code>DOMTokenList</code> using {{domxref("Element.classList")}}, add a class using {{domxref("DOMTokenList.add()")}}, and then update the {{domxref("Node.textContent")}} of the <code>&lt;p&gt;</code> to equal the <code>DOMTokenList</code>.</p>

<p>First, the HTML:</p>

<pre class="brush: html">&lt;p class="a b c"&gt;&lt;/p&gt;</pre>

<p>Now the JavaScript:</p>

<pre class="brush: js">let para = document.querySelector("p");
let classes = para.classList;
para.classList.add("d");
para.textContent = `paragraph classList is "${classes}"`;</pre>

<p>The output looks like this:</p>

<p>{{ EmbedLiveSample('Examples', '100%', 60) }}</p>

<h2 id="Trimming_of_whitespace_and_removal_of_duplicates">Trimming of whitespace and removal of duplicates</h2>

<p>Methods that modify the <code>DOMTokenList</code> (such as {{domxref("DOMTokenList.add()")}}) automatically trim any excess {{Glossary("Whitespace")}} and remove duplicate values from the list. For example:</p>

<pre class="brush: html">&lt;span class="    d   d e f"&gt;&lt;/span&gt;</pre>

<pre class="brush: js">let span = document.querySelector("span");
let classes = span.classList;
span.classList.add("x");
span.textContent = `span classList is "${classes}"`;</pre>

<p>The output looks like this:</p>

<p>{{ EmbedLiveSample('Trimming_of_whitespace_and_removal_of_duplicates', '100%', 60) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#interface-domtokenlist", "DOMTokenList")}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DOMTokenList")}}</p>
